using Bp.Sync.BackEnd.Infrastructure.ElasticDbContext;
using Bp.Sync.Domain.Elastics.Inventories.Products;
using Bp.Sync.Dto.Results;
using Bp.Sync.Dto.SmartTable;
using Microsoft.Extensions.Options;
using Nest;
using System;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace Bp.Sync.BackEnd.Infrastructure.Repositories
{
    public interface IProductBillRepository
    {
        Task<BaseResult> Add(ProductBillElastic ProductBill);

        Task<BaseResult> AddManyAsync(IEnumerable<ProductBillElastic> ProductBills);

        Task<SmartTableResult<ProductBillElastic>> SearchBySort(BoolQueryDescriptor<ProductBillElastic> query, SortDescriptor<ProductBillElastic> searchDescriptor, int count);

        Task<SmartTableResult<ProductBillElastic>> Search(BoolQueryDescriptor<ProductBillElastic> query);

        Task<SmartTableResult<ProductBillElastic>> Search(BoolQueryDescriptor<ProductBillElastic> query, int count);

        Task<SmartTableResult<ProductBillElastic>> GetByIds(List<long> ids);

        Task<ISearchResponse<ProductBillElastic>> SearchAgg(BoolQueryDescriptor<ProductBillElastic> query, AggregationContainerDescriptor<ProductBillElastic> aggs);
    }

    public class ProductBillRepository : IProductBillRepository
    {
        private readonly ElasticIndex<ProductBillElastic> _dbContext;

        public ProductBillRepository(IOptions<ElasticConnectionSettings> settings)
        {
            _dbContext = new ElasticIndex<ProductBillElastic>(settings.Value.ClusterUrl, "inventoryproductbill");
        }

        public async Task<SmartTableResult<ProductBillElastic>> Search(BoolQueryDescriptor<ProductBillElastic> query)
        {
            return await _dbContext.Search(query);
        }

        public async Task<BaseResult> Add(ProductBillElastic ProductBill)
        {
            var result = new BaseResult() { Result = Dto.Results.Result.Success };
            var rs = await _dbContext.Insert(ProductBill);
            if (rs.IsValid)
            {
                result.Result = Dto.Results.Result.Success;
            }
            else
            {
                result.Result = Dto.Results.Result.SystemError;
                result.Message = "Không tạo được bản ghi";
            }
            return result;
        }

        public async Task<BaseResult> AddManyAsync(IEnumerable<ProductBillElastic> ProductBills)
        {
            var result = new BaseResult { Result = Dto.Results.Result.Success };
            try
            {
                var rs = await _dbContext.InsertMany(ProductBills);
                if (rs.IsValid) return result;
                else
                {
                    result.Result = Dto.Results.Result.Failed;
                    result.Message = rs.Errors.ToString();
                    return result;
                }
            }
            catch (Exception exx)
            {
                result.Result = Dto.Results.Result.Failed;
                result.Message = exx.Message.ToString();
                return result;
            }
        }

        public async Task<SmartTableResult<ProductBillElastic>> GetByIds(List<long> ids)
        {
            var query = new BoolQueryDescriptor<ProductBillElastic>();
            var idsQ = new QueryContainerDescriptor<ProductBillElastic>();
            idsQ.Terms(t => t.Field(f => f.Id).Terms(ids));
            query.Filter(fl => idsQ);
            return await _dbContext.Search(query);
        }

        public async Task<SmartTableResult<ProductBillElastic>> Search(BoolQueryDescriptor<ProductBillElastic> query, int count)
        {
            return await _dbContext.Search(query, count);
        }

        public async Task<ISearchResponse<ProductBillElastic>> SearchAgg(BoolQueryDescriptor<ProductBillElastic> query, AggregationContainerDescriptor<ProductBillElastic> aggs)
        {
            return await _dbContext.SearchAgg(query, aggs);
        }

        public async Task<SmartTableResult<ProductBillElastic>> SearchBySort(BoolQueryDescriptor<ProductBillElastic> query, SortDescriptor<ProductBillElastic> searchDescriptor, int count)
        {
            return await _dbContext.SearchBySort(query, searchDescriptor, count);
        }
    }
}